package com.microservices.pms.project.service.impl;

import com.microservices.common.core.exception.ServiceException;
import com.microservices.common.core.utils.DateUtils;
import com.microservices.pms.project.domain.PmsProjectTestcaseType;
import com.microservices.pms.project.mapper.PmsProjectTestcaseTypeMapper;
import com.microservices.pms.project.service.IPmsProjectTestcaseTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 测试用例类型管理Service业务层处理
 *
 * @author otto
 * @date 2023-11-22
 */
@Service
public class PmsProjectTestcaseTypeServiceImpl implements IPmsProjectTestcaseTypeService {
    @Autowired
    private PmsProjectTestcaseTypeMapper pmsProjectTestcaseTypeMapper;

    /**
     * 查询测试用例类型管理
     *
     * @param id 测试用例类型管理主键
     * @return 测试用例类型管理
     */
    @Override
    public PmsProjectTestcaseType selectPmsProjectTestcaseTypeById(Long id) {
        PmsProjectTestcaseType pmsProjectTestcaseType = pmsProjectTestcaseTypeMapper.selectPmsProjectTestcaseTypeById(id);
        if (pmsProjectTestcaseType == null) {
            throw new ServiceException("该测试用例类型不存在(类型ID[%s])", id);
        }
        return pmsProjectTestcaseType;
    }

    /**
     * 查询测试用例类型管理列表
     *
     * @param pmsProjectTestcaseType 测试用例类型管理
     * @return 测试用例类型管理
     */
    @Override
    public List<PmsProjectTestcaseType> selectPmsProjectTestcaseTypeList(PmsProjectTestcaseType pmsProjectTestcaseType) {
        return pmsProjectTestcaseTypeMapper.selectPmsProjectTestcaseTypeList(pmsProjectTestcaseType);
    }

    /**
     * 新增测试用例类型管理
     *
     * @param pmsProjectTestcaseType 测试用例类型管理
     * @return 结果
     */
    @Override
    public int insertPmsProjectTestcaseType(PmsProjectTestcaseType pmsProjectTestcaseType) {
        pmsProjectTestcaseType.setCreateTime(DateUtils.getNowDate());
        return pmsProjectTestcaseTypeMapper.insertPmsProjectTestcaseType(pmsProjectTestcaseType);
    }

    /**
     * 修改测试用例类型管理
     *
     * @param pmsProjectTestcaseType 测试用例类型管理
     * @return 结果
     */
    @Override
    public int updatePmsProjectTestcaseType(PmsProjectTestcaseType pmsProjectTestcaseType) {
        pmsProjectTestcaseType.setUpdateTime(DateUtils.getNowDate());
        return pmsProjectTestcaseTypeMapper.updatePmsProjectTestcaseType(pmsProjectTestcaseType);
    }

    /**
     * 批量删除测试用例类型管理
     *
     * @param ids 需要删除的测试用例类型管理主键
     * @return 结果
     */
    @Override
    public int deletePmsProjectTestcaseTypeByIds(Long[] ids) {
        return pmsProjectTestcaseTypeMapper.deletePmsProjectTestcaseTypeByIds(ids);
    }

    /**
     * 删除测试用例类型管理信息
     *
     * @param id 测试用例类型管理主键
     * @return 结果
     */
    @Override
    public int deletePmsProjectTestcaseTypeById(Long id) {
        return pmsProjectTestcaseTypeMapper.deletePmsProjectTestcaseTypeById(id);
    }

    @Override
    public PmsProjectTestcaseType selectDefaultPmsProjectTestcaseType() {
        return pmsProjectTestcaseTypeMapper.selectDefaultPmsProjectTestcaseType();
    }
}
